; Affichage d'une carte pour Strip 21
;

; version 0.2, optimisation affichage, on ne change que l'octet du caractere ASCII
; sauf pour l'affichage du fond de la carte 

; version 0.3, rajout affichage des cartes numerotees. Pas forcament super compact, mais
; bon...

; version 0.4, separation des routines d'effacement et d'affichage
; on essaie aussi d'optimiser l'occupation memoire 
; version 0.3 = &213
; version 0.4 = &1F8 ; pas terrible...

; Version 0.5, rajout bord haut specifique si la carte affichee se fait
; par dessus ne autre

; Version 0.6, linkage avec routine d'affichage d'Elsa et repositionnement du sprite

; Version 0.7, decalage d'un caractere vers la gauche de la fenetre principale

; Version 0.8, rajout routine permettant d'afficher n'importe ou une carte sans effet de
; superposition sur une autre carte (bord haut)

; version 0.9, on integre a la fin du code les graphismes SETEG des cartes
; ca permettra de laisser la page de presentation du jeu pendant le chargement !

; Pour le linkage final du programme
; Reorganisation memoire pour tenir compte des images recuperees dans Memo-Strip.

; &5880 = CARDS.BIN longueur &678 - end en &
; &5F47 = STRIP21.GFX longueur &2082 - end en &7FC9
; &7FC9 - &5880 = &2749



ORG &5880
; NOLIST
WRITE "CARDS.BIN"

base_video equ &4000
base_graphics equ &5F47

vector_init_tiles equ &1B

nb_images equ 11

JP clean_carpet          ; &5880
JP clean_playmate        ; &5883
JP aff_card_boot         ; &5886
JP aff_elsa              ; &5889
JP init_card_graphics    ; &588C

carte db 1		 ; &588F
couleur db &0		 ; &5890
posx db &1      	 ; &5891
posy db &1               ; &5892
base_carte defw &0       ; &5893
elsa db &0               ; &5895
flag_superposition db &0 ; &5896

; sprites des figures valet, dame, roi
; correspondent a des SETEG

spr_valet DB 164,207,208,209,164,210,211,196,197,164,212,170,171,172,173,199,175,176,177,200,179,180,181,182,213,164,202,203,186,214,164,215,216,217,164
spr_dame  DB 164,192,162,193,164,194,195,196,197,164,198,170,171,172,173,199,175,176,177,200,179,180,181,182,201,164,202,203,204,205,164,188,189,206,164
spr_roi   DB 160,161,162,163,164,165,166,167,168,164,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,164,184,185,186,187,164,188,189,190,191
 
; autres sprites, bords d'une carte
; 90 91 92
; 93 94 95
; 96 97 98

; sprites couleur grande 
; carreau
; 99 100 101 102

; sprites couleur petit
; carreau coeur pique trefle
; 103 104 105 106

; sprites numero de carte
; 107 a 119

; On efface la partie droite de l'ecran (celle devolue aux cartes
clean_carpet
	DI
	PUSH IX
	PUSH HL
	LD HL,&4000+24
	LD A,23
	LD E,128+&40+04
	LD D,128+63  ; 63 = caractere blanc
	LD C,28 ; largeur de la fenetre a effacer

clear_screen2
	PUSH AF
	PUSH HL
	LD B,C
clear_screen1
	LD (HL),D
	INC HL
	LD (HL),E
	INC HL
	DJNZ clear_screen1
	POP HL

	LD A,L
	ADD A,80
	JR NC,clear_screen3
	INC H
clear_screen3
	LD L,A
	POP AF
	DEC A
	JR NZ,clear_screen2

back_to_basic
	POP HL
	POP IX
	EI
	RET

clean_playmate
	DI
	PUSH IX
	PUSH HL
	LD HL,&4000+4
	LD A,23
	LD E,6  ; couleur cyan
	LD D,32 ; caractere blanc fonte texte
	LD C,9 ; largeur de la fenetre a effacer
	JR clear_screen2

; Affichage du fond d'une carte
aff_fond

	LD HL,base_video-80
	LD BC,80
	
	LD A,(posy)
aff_fond1	
	ADD HL,BC
	DEC A
	JR NZ,aff_fond1
	LD A,(posx)	
	RLA	
	LD C,A
	LD B,&0
	ADD HL,BC ; Dans HL, on pointe sur le bord haut gauche de la carte a afficher
	LD (base_carte),HL
	
	LD D,128+&40+7 ; mode graphique, fond bleu, avant plan blanc

	LD E,128+&70 ; mode graphique, fond noir, avant-plan blanc
	
	LD A,(couleur)
	SUB &3
	JR C,fond_rouge


	JR fond_noir

fond_rouge
	INC E ;	LD E,128+&70+1 ; mode graphique, fond rouge, avant-plan blanc
	
fond_noir
	LD A,(flag_superposition) ; si O, pas de superposition
	AND A
	JR Z,no_superposition
	LD A,120+128
	JR no_superposition2

no_superposition
	LD A,90+128 ; caracteres 90, 91, 92
no_superposition2
	PUSH DE
	LD E,D
	CALL aff_ligne ; bord haut de la carte
	POP DE
	
	LD B,9 ; hauteur de la carte sans les bords 
aff_fond2	
	PUSH BC
	LD A,93+128 ; caracteres 93, 94, 95
	CALL aff_ligne
	POP BC
	DJNZ aff_fond2
	
	LD A,96+128 ; caracteres 96, 97, 98
	LD E,D
    JR aff_ligne ; on peut optimiser en virant ce saut si aff_ligne reste en dessous
	
aff_ligne	
	LD (HL),A 
	INC L
	LD (HL),D 
	INC HL
	LD B,7 ; largeur d'une carte sans les bords
	INC A
aff_ligne1
	LD (HL),A
	INC L
	LD (HL),E
	INC HL
	DJNZ aff_ligne1
	INC A
	LD (HL),A
	INC L
	LD (HL),D  
	LD BC,80-17
	ADD HL,BC ; ligne suivante
	RET

; Affichage du fond d'une carte retournee, utile pour mode Banco

aff_cache
	LD HL,(base_carte)
	LD BC,82
	ADD HL,BC
	LD B,&9
aff_cache2
	PUSH BC
	LD B,&7
aff_cache1
	LD (HL),123+128 ; caractere carte cachee
	INC HL
	LD (HL),128+&10+4 
	INC HL
	DJNZ aff_cache1
	LD BC,66
	ADD HL,BC
	POP BC
	DJNZ aff_cache2
	JP back_to_basic

; Affichage des petites couleurs sur les bords	
; deux sprites par couleur, utile pour le carreau afin d'avoir une symetrie
	
aff_couleur_small

	LD A,(carte)
	ADD A,106+128 ; sprites entre 107 et 119
	LD D,A

	LD A,(couleur)
	ADD A,98+128  ; sprite entre 99 et 102
	
	LD HL,(base_carte)
	LD BC,80*1+2
	ADD HL,BC
	CALL aff_small2
	
	LD BC,68
	ADD HL,BC
	CALL aff_small1
	
	LD BC,80*5+68
	ADD HL,BC
	CALL aff_small1
	
	LD BC,68
	ADD HL,BC

aff_small2
	PUSH AF
	LD A,D
	CALL aff_small1
	POP AF
	RET
	
aff_small1	

	LD (HL),A
	LD BC,12
	ADD HL,BC
	LD (HL),A
	RET	
	
; Appel routine principale affichage d'une carte
; ===============================================
	
aff_card_boot
	DI
	PUSH IX
	PUSH HL
	CALL aff_fond
	
	LD A,(carte)
	AND A
	JP Z,aff_cache

	SUB 11
	JR C,no_figure
	
	LD HL,spr_valet-35
	LD BC,35
	INC A
calc_figure
	ADD HL,BC
	DEC A
	JR NZ,calc_figure
	
	EX DE,HL ; on sauvegarde le sprite a afficher
	
	LD HL,(base_carte)
	LD BC,80*2+4
	ADD HL,BC  ; decalage de x lignes vers le bas par rapport au haut de la caste
	EX DE,HL
	
	LD B,7
	LD A,&F0 ; 128 + fond blanc + premier plan noir
	
aff_figure	
	PUSH BC
	LDI
	INC DE
	
	LDI
	INC DE
	
	LDI
	INC DE
	
	LDI
	INC DE
	
	LDI
	
	EX DE,HL
	LD BC,71 ; 80-5*2+1
	ADD HL,BC
	EX DE,HL
	POP BC
	DJNZ aff_figure
	
aff_figure2
	CALL aff_couleur_small
	JP back_to_basic
	
	
; affichage des cartes de 1 a 10
; en entree, A=numero de carte-11

no_figure

	ADD A,11 ; on recupere le pointeur sur la table de la carte
	LD BC,&07
	LD HL,carte_01 -7 ; table des lignes des cartes avec numeros  0 = ligne vide, 1 = un caractere, 2 = 2 caracteres

no_figure0	
	ADD HL,BC
	DEC A
	JR NZ,no_figure0 
	
	PUSH HL
	POP IX

	LD A,(couleur)
	ADD A,102+128  ; sprite entre 103 et 106
	LD E,A
	
	LD HL,(base_carte)
	LD BC,80*2
	ADD HL,BC

	LD B,&7
	
no_figure3

	PUSH BC	
	LD A,(IX+&0)
	INC IX

	AND A   ; une ligne sans couleur
	JR NZ,no_figure1
	LD BC,80
	ADD HL,BC

no_figure1
	CP 1
	CALL Z,aff_1 ; en sortie A=&FF
	CP 2
	CALL Z,aff_2 ; en sortie A=&FF
	POP BC
	DJNZ no_figure3
	JR aff_figure2

; affichage d'une ligne de deux symboles	
; et passage a la ligne suivante

aff_2	
	LD BC,4
	ADD HL,BC
	LD (HL),E
	LD BC,08
	ADD HL,BC
	LD BC,68
aff_3
	LD (HL),E
	ADD HL,BC
	RET

; affichage d'une ligne d'un seul symbole
; et passage a la ligne suivante
	
aff_1
	LD BC,8
	ADD HL,BC
	LD BC,72
	JR aff_3	

; table des lignes des cartes avec numeros  0 = ligne vide, 1 = un caractere, 2 = 2 caracteres

carte_01 db 0,0,0,1,0,0,0
carte_02 db 0,0,1,0,1,0,0
carte_03 db 0,1,0,1,0,1,0
carte_04 db 0,2,0,0,0,2,0
carte_05 db 0,2,0,1,0,2,0
carte_06 db 0,2,0,2,0,2,0
carte_07 db 2,1,0,2,0,0,2
carte_08 db 2,0,2,0,2,0,2
carte_09 db 2,0,2,1,2,0,2
carte_10 db 2,1,2,0,2,1,2

tab_nb_chars db 66,65,73,68,70,72,83,67,72,68,50


; bout de code rajoute en derniere minutes
; suite a l'integration dans le source des graphiques des cartes.
; objectif, pouvoir afficher une belle page ecran pendant le chargement du jeu
; (sur la beta, les graphismes des cartes etaient initialises dans un autre listing).

init_card_graphics

	DI
	PUSH IX
	PUSH HL

	LD A,128+32  ; caracteres graphiques a definir a partie de 32
	LD B,92      ; nombre de caracteres a redefinir (123 - 32)
	LD HL,char32 ; table de caracteres graphiques pour les cartes
	CALL init_tiles1
	JP back_to_basic
	
init_tiles

	LD B,A
	LD A,33

init_tiles1
	PUSH BC
	PUSH AF
	PUSH HL
	
	CALL vector_init_tiles
	POP HL
	LD BC,&A
	ADD HL,BC
	POP AF
	INC A
	POP BC
	DJNZ init_tiles1
	RET

; En entree, HL=table des caracteres a afficher non compactee

aff_img PUSH HL
	POP IX  ; dans IX, table des caracteres

	LD HL,&4004+160 ; Colonne 1 ligne 0
	LD E,&00
	LD D,&00

	LD B,7
aff_img2
	PUSH BC
	PUSH HL

	LD B,18
aff_img1
	PUSH BC

	LD A,E
	AND A
	JR NZ,decomp_rle

	LD A,(IX+&0)
	INC IX
	BIT 7,A
	JR Z,aff_img0
	RES 7,A

	LD E,A
decomp_rle
	LD A,1
	DEC E

aff_img0
	ADD A,31+128
	LD (HL),A
	INC HL
	LD (HL),D   ; couleur
	LD BC,79   ; on passe au caractere sur la ligne suivante
	ADD HL,BC
	POP BC
	DJNZ aff_img1

	POP HL	
	INC HL
	INC HL
	POP BC
	DJNZ aff_img2
	RET

; oh oh !

aff_elsa
	DI
	PUSH IX
	PUSH HL

	LD A,(elsa) ; numero de l'image a afficher (0 a 10)

	LD C,A

	LD HL,tab_nb_chars
	ADD A,L
	LD L,A

	LD A,(HL) ; nombre de tuiles a redefinir
	PUSH AF

	LD A,C	
	ADD A,A ; x2
	LD B,&0
	LD C,A
	LD HL,base_graphics
	ADD HL,BC ; hop, on pointe sur la table des caracteres a afficher

	POP AF
	PUSH HL

	LD E,(HL)
	INC HL
	LD D,(HL)
	EX DE,HL

	CALL init_tiles
	POP HL
	LD BC,nb_images*2
	ADD HL,BC ; on pointe sur le pointeur vers la table des caracteres a afficher

	LD E,(HL)
	INC HL
	LD D,(HL)

	EX DE,HL; dans HL, liste des caracteres a afficher dans la memoire video

	CALL aff_img
	JP back_to_basic
	
; datas graphismes cartes 

char32 DB &00,&00,&00,&00,&00,&00,&00,&00,&00,&10
char33 DB &00,&00,&01,&08,&07,&03,&03,&01,&01,&01
char34 DB &04,&22,&17,&BF,&FF,&FC,&F0,&C2,&C0,&40
char35 DB &90,&60,&E0,&E0,&C0,&40,&40,&20,&20,&10
char36 DB &00,&00,&00,&00,&00,&00,&00,&00,&00,&00
char37 DB &38,&38,&38,&38,&38,&38,&38,&39,&3A,&3C
char38 DB &02,&0D,&3B,&55,&2E,&38,&7C,&82,&01,&00
char39 DB &E0,&B3,&1C,&07,&0F,&04,&06,&09,&08,&F0
char40 DB &F0,&C0,&40,&C0,&E0,&E0,&00,&C0,&30,&0C
char41 DB &38,&38,&78,&B8,&B8,&B9,&B9,&FD,&93,&90
char42 DB &00,&10,&20,&40,&C0,&C0,&C0,&C0,&C0,&C0
char43 DB &00,&00,&01,&01,&01,&01,&01,&01,&01,&01
char44 DB &02,&01,&02,&05,&0A,&15,&2A,&54,&A8,&50
char45 DB &00,&00,&80,&40,&C0,&20,&20,&10,&10,&10
char46 DB &90,&80,&80,&40,&40,&20,&20,&20,&10,&10
char47 DB &30,&0C,&03,&00,&00,&00,&00,&01,&02,&05
char48 DB &02,&05,&0A,&D5,&2A,&54,&AB,&50,&A0,&40
char49 DB &A0,&40,&80,&00,&00,&00,&00,&C0,&30,&0C
char50 DB &08,&08,&04,&04,&04,&02,&02,&01,&01,&09
char51 DB &08,&08,&08,&04,&04,&03,&02,&01,&00,&00
char52 DB &0A,&15,&2A,&54,&A8,&50,&A0,&40,&80,&40
char53 DB &80,&80,&80,&80,&80,&80,&80,&80,&00,&00
char54 DB &03,&03,&03,&03,&03,&03,&02,&04,&08,&00
char55 DB &09,&C9,&BF,&9D,&9D,&1D,&1D,&1E,&1C,&1C
char56 DB &30,&0C,&03,&00,&07,&07,&03,&02,&03,&0F
char57 DB &0F,&10,&90,&60,&20,&F0,&E0,&38,&CD,&87
char58 DB &00,&80,&40,&3F,&1C,&74,&AA,&DC,&B0,&40
char59 DB &3C,&5C,&9C,&1C,&1C,&1C,&1C,&1C,&1C,&1C
char60 DB &08,&04,&04,&02,&02,&03,&07,&07,&06,&09
char61 DB &02,&03,&43,&0F,&3F,&FF,&FD,&E8,&44,&20
char62 DB &80,&80,&80,&C0,&C0,&E0,&10,&80,&00,&00
char63 DB &08,&00,&00,&00,&00,&00,&00,&00,&00,&00
char64 DB &00,&00,&01,&08,&07,&03,&03,&01,&01,&03
char65 DB &90,&60,&E0,&E0,&C0,&40,&40,&40,&20,&10
char66 DB &54,&38,&6C,&38,&10,&15,&18,&51,&32,&14
char67 DB &06,&1D,&2B,&55,&AE,&58,&7C,&82,&01,&00
char68 DB &C0,&80,&03,&00,&1F,&04,&06,&09,&08,&F0
char69 DB &F0,&40,&C0,&40,&80,&00,&00,&C0,&30,&0C
char70 DB &18,&30,&50,&90,&90,&91,&91,&91,&83,&80
char71 DB &80,&80,&80,&40,&40,&20,&20,&20,&10,&10
char72 DB &08,&08,&04,&04,&04,&02,&02,&01,&01,&01
char73 DB &01,&C1,&89,&89,&89,&09,&09,&0A,&0C,&08
char74 DB &30,&0C,&03,&00,&00,&01,&02,&03,&02,&0F
char75 DB &0F,&10,&90,&60,&20,&F8,&00,&C0,&01,&03
char76 DB &00,&80,&40,&3F,&1A,&75,&AA,&D4,&B8,&60
char77 DB &18,&2C,&CA,&98,&A8,&08,&1C,&36,&1C,&2A
char78 DB &C0,&80,&80,&C0,&C0,&E0,&10,&80,&00,&00
char79 DB &00,&00,&00,&01,&03,&07,&0F,&03,&01,&01
char80 DB &01,&0F,&FF,&FF,&FF,&FC,&F0,&C2,&C0,&40
char81 DB &80,&E0,&F0,&E0,&C0,&40,&40,&20,&20,&10
char82 DB &00,&00,&00,&00,&00,&00,&00,&03,&04,&08
char83 DB &02,&0D,&3B,&55,&2E,&38,&FC,&02,&01,&00
char84 DB &10,&20,&40,&80,&80,&81,&81,&81,&83,&80
char85 DB &01,&C1,&81,&81,&81,&01,&01,&02,&04,&08
char86 DB &10,&20,&C0,&00,&00,&00,&00,&00,&00,&00
char87 DB &08,&04,&04,&02,&02,&03,&07,&0F,&07,&01
char88 DB &02,&03,&43,&0F,&3F,&FF,&FF,&FF,&F0,&80
char89 DB &80,&80,&C0,&F0,&E0,&C0,&80,&00,&00,&00




; bordures de la carte
; haut
char90 DB &00,&00,&00,&00,&00,&07,&0F,&0F,&0F,&0F
char91 DB &00,&00,&00,&00,&00,&FF,&FF,&FF,&FF,&FF
char92 DB &00,&00,&00,&00,&00,&E0,&F0,&F0,&F0,&F0

; cotes
char93 DB &0F,&0F,&0F,&0F,&0F,&0F,&0F,&0F,&0F,&0F
char94 DB &00,&00,&00,&00,&00,&00,&00,&00,&00,&00
char95 DB &F0,&F0,&F0,&F0,&F0,&F0,&F0,&F0,&F0,&F0

; bas
char96 db &0F,&0F,&0F,&0F,&07,&00,&00,&00,&00,&00
char97 db &FF,&FF,&FF,&FF,&FF,&00,&00,&00,&00,&00
char98 db &F0,&F0,&F0,&F0,&E0,&00,&00,&00,&00,&00

; petit carreau 
char99 db &00,&00,&00,&10,&38,&38,&10,&00,&00,&00

; petit coeur
char100 db &00,&00,&00,&28,&38,&38,&10,&00,&00,&00

; petit pique
char101 db &00,&00,&10,&38,&38,&10,&38,&00,&00,&00

; petit trefle
char102 db &00,&00,&00,&10,&28,&10,&38,&00,&00,&00

; carreau, coeur, pique, trefle
char103 db &00,&10,&38,&7C,&FE,&7C,&38,&10,&00,&00
char104 db &00,&6C,&FE,&FE,&FE,&7C,&38,&10,&00,&00
char105 db &00,&18,&3C,&7E,&7E,&7E,&18,&3C,&00,&00
char106 db &00,&38,&38,&D6,&FE,&D6,&10,&38,&00,&00

; chiffres de 1 a 10 et figure de V a R

char107 db &00,&10,&28,&28,&38,&28,&28,&00,&00,&00
char108 db &00,&38,&28,&08,&38,&20,&38,&00,&00,&00
char109 db &00,&38,&28,&18,&08,&28,&38,&00,&00,&00
char110 db &00,&20,&28,&28,&38,&08,&08,&00,&00,&00
char111 db &00,&38,&20,&38,&08,&28,&38,&00,&00,&00
char112 db &00,&38,&20,&38,&28,&28,&38,&00,&00,&00
char113 db &00,&38,&08,&08,&10,&10,&10,&00,&00,&00
char114 db &00,&38,&28,&38,&28,&28,&38,&00,&00,&00
char115 db &00,&38,&28,&28,&38,&08,&38,&00,&00,&00
char116 db &00,&27,&65,&25,&25,&25,&77,&00,&00,&00
char117 db &00,&28,&28,&28,&28,&10,&10,&00,&00,&00
char118 db &00,&30,&28,&28,&28,&28,&30,&00,&00,&00
char119 db &00,&30,&28,&28,&30,&28,&28,&00,&00,&00

;  bord haut de la carte si une carte a deja ete affichee au dessus
              
char120 db &0F,&0F,&0F,&0F,&00,&07,&0F,&0F,&0F,&0F
char121 db &FF,&FF,&FF,&FF,&00,&FF,&FF,&FF,&FF,&FF
char122 db &F0,&F0,&F0,&F0,&00,&E0,&F0,&F0,&F0,&F0
char123 db &55,&AA,&55,&AA,&55,&AA,&55,&AA,&55,&AA
